// Endogenous variables 
var Welf1, 
Welf2, 
instr1, 
instr2,  
 
Util1, 
Util2, 
c1c, 
c1cd, 
c1mc, 
c1y, 
c1g, 
c1rpcpd, 
c1pid, 
c1hp, 
c1gp, 
c1pstar, 
c1deltad, 
c1rn, 
c1rer, 
c1dcore, 
c1ngdp, 
c1pcore, 
c1dnxf, 
c2c, 
c2cd, 
c2mc, 
c2y, 
c2g, 
c2rpcpd, 
c2pid, 
c2hp, 
c2gp, 
c2pstar, 
c2deltad, 
c2rn, 
c2rer, 
c2dcore, 
c2ngdp, 
c2pcore, 
c2dnxf, 
Welfcon1,  
c1deltadlag,  
c1ngdplag,  
c1pcorelag,  
c1rerlag,  
c1rnlag,  
c1rpcpdlag,  
c1ylag,  
c2deltadlag,  
c2ngdplag,  
c2pcorelag,  
c2rerlag,  
c2rnlag,  
c2rpcpdlag,  
c2ylag;  
 
// Exogenous variables  
var c1shockgy, 
c1z, 
c1taupvar, 
c2shockgy, 
c2z, 
c2taupvar; 
 
varexo  c1shockgyerr 
c1zerr 
c2shockgyerr 
c2zerr 
c2taupvarerr 
c1taupvarerr 
c1monerr 
c2monerr; 
 
parameters   
omega_welf1, 
omega_welf2, 
nbeta, 
c1sigma, 
c1beta, 
c1rhoc,              
c1sharegy,           
c1rhogy,             
c1sigmagy,   
c1rhoz,            
c1sigmaz,        
c2sigma,             
c2beta,              
c2rhoc,              
c2sharegy,           
c2rhogy,             
c2sigmagy,  
c2rhoz,            
c2sigmaz,        
c2rhotaupvar,      
c2sigmataupvarerr, 
c1rhotaupvar,      
c1sigmataupvarerr, 
c2chi,               
c1chi,               
c2nup,            
c1nup,            
c2xip,               
c1xip,               
c1chi0, 
c1omegac, 
c1omegamc, 
c1relc2, 
c1pistar, 
c1taup, 
c2chi0, 
c2omegac, 
c2omegamc, 
c2pistar, 
c2taup, 
c1rnss, 
c2rnss, 
c1gamrn,                       
c1gamdpc,                         
c2gamrn,             
c2gamdpc, 
c2lambdaqss, 
c2rpcpdss, 
c1rerss, 
c1lambdaqss, 
c1rpcpdss; 
 
var c1lmult1,  c1lmult2,  c1lmult3,  c1lmult4,  c1lmult5,  c1lmult6,   
    c1lmult7,  c1lmult8,  c1lmult9,  c1lmult10,  c1lmult11,  c1lmult12,   
    c1lmult13,  c1lmult14,  c1lmult15,  c1lmult16,  c1lmult17,  c1lmult18,   
    c1lmult19,  c1lmult20,  c1lmult21,  c1lmult22,  c1lmult23,  c1lmult24,   
    c1lmult25,  c1lmult26,  c1lmult27,  c1lmult28,  c1lmult29,  c1lmult30,   
    c1lmult31,  c1lmult32,  c1lmult33,  c1lmult34,  c1lmult35,  c1lmult36,   
    c1lmult37,  c1lmult38,  c1lmult39,  c1lmult40,  c1lmult41,  c1lmult42,   
    c1lmult43,  c1lmult44,  c1lmult45,  c1lmult46,  c1lmult47,  c1lmult48,   
    c1lmult49,  c2lmult1,  c2lmult2,  c2lmult3,  c2lmult4,  c2lmult5,   
    c2lmult6,  c2lmult7,  c2lmult8,  c2lmult9,  c2lmult10,  c2lmult11,   
    c2lmult12,  c2lmult13,  c2lmult14,  c2lmult15,  c2lmult16,  c2lmult17,   
    c2lmult18,  c2lmult19,  c2lmult20,  c2lmult21,  c2lmult22,  c2lmult23,   
    c2lmult24,  c2lmult25,  c2lmult26,  c2lmult27,  c2lmult28,  c2lmult29,   
    c2lmult30,  c2lmult31,  c2lmult32,  c2lmult33,  c2lmult34,  c2lmult35,   
    c2lmult36,  c2lmult37,  c2lmult38,  c2lmult39,  c2lmult40,  c2lmult41,   
    c2lmult42,  c2lmult43,  c2lmult44,  c2lmult45,  c2lmult46,  c2lmult47,   
    c2lmult48,  c2lmult49,  Util,  Welf; 
  
model; 
 
////////////////////////////////// 
// Utility and Welfare bloc 
////////////////////////////////// 
 
//// Utility, aggregate  
Util = omega_welf1*Util1+omega_welf2*Util2; 
 
//// Welfare, aggregate  
Welf = Util + nbeta*Welf(1); 
 
// Welfare, agent 1 
Welf1 = Util1 + nbeta*Welf1(1); 
 
// Welfare, agent 2 
Welf2 = Util2+ nbeta*Welf2(1); 
 
// Policy instrument, agent 1 
instr1 = c1dcore; 
 
// Policy instrument, agent 2 
instr2 = c2dnxf; 
 
 c1deltadlag =c1deltad(-1);  
c1ngdplag =c1ngdp(-1);  
c1pcorelag =c1pcore(-1);  
c1rerlag =c1rer(-1);  
c1rnlag =c1rn(-1);  
c1rpcpdlag =c1rpcpd(-1);  
c1ylag =c1y(-1);  
c2deltadlag =c2deltad(-1);  
c2ngdplag =c2ngdp(-1);  
c2pcorelag =c2pcore(-1);  
c2rerlag =c2rer(-1);  
c2rnlag =c2rn(-1);  
c2rpcpdlag =c2rpcpd(-1);  
c2ylag =c2y(-1);  
  
////////////////////////////////// 
// Monetary policy bloc 
////////////////////////////////// 
 
// Policymaker's First-Order Conditions for Country 1 
exp(c1c)/exp(c1c)^c1sigma + c1lmult21*exp(c1c) - c1lmult23*((c1chi0*c1sigma*exp(c1c)*exp(c1rpcpd)*exp(c1y)*exp(c1c)^(c1sigma - 1)*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1beta*c1sigma*c1xip*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1hp(+1))*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1))/(exp(c1c(+1))^c1sigma*(c1pistar/c1pid(+1))^(((c1chi + 1)*(c1nup + 1))/c1nup))) - (c1lmult17*exp(c1c))/exp(c1c)^c1sigma - (c1omegamc*c1lmult20*c1rhoc*exp(-c1mc)*exp(c1c)*(c1omegamc*exp(-c1mc)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - c1lambdaqss*c1lmult46*c1rerss*c1rpcpdss*c1sigma*exp(-c1rer)*exp(c1c)*exp(c1c)^(c1sigma - 1) + (c1omegac*c1lmult19*c1rhoc*exp(-c1cd)*exp(c1c)*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - (c1beta*c1lmult18*c1sigma*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1))/(c1pid(+1)*exp(c1c(+1))^c1sigma) + (c1beta*c1lmult18(-1)*c1sigma*exp(-c1rpcpd)*exp(c1c)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid*nbeta*exp(c1c)^(c1sigma + 1)) - (c1beta*c1lmult24*c1sigma*c1xip*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1gp(+1))*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1)*(c1pistar/c1pid(+1))^(1 - (c1nup + 1)/c1nup))/exp(c1c(+1))^c1sigma + (c1beta*c1lmult24(-1)*c1sigma*c1xip*exp(-c1rpcpd)*exp(c1c)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^(c1sigma + 1)) + (c1beta*c1lmult23(-1)*c1sigma*c1xip*exp(-c1rpcpd)*exp(c1c)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^(c1sigma + 1)*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)); 
- c1lmult27*exp(c1cd) - c1omegac^(c1rhoc/(c1rhoc + 1))*c1lmult21*exp(c1cd)*exp(c1cd)^(1/(c1rhoc + 1) - 1)*(c1omegac^(c1rhoc/(c1rhoc + 1))*exp(c1cd)^(1/(c1rhoc + 1)) + c1omegamc^(c1rhoc/(c1rhoc + 1))*exp(c1mc)^(1/(c1rhoc + 1)))^c1rhoc - (c1omegac*c1lmult19*c1rhoc*exp(-c1cd)*exp(c1c)*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1); 
c1lmult29 - c1lmult1 + c1lmult31 - (c1lmult49*exp(c2dnxf))/c2dcore + (c2dcore*c1lmult48*exp(c1dnxf))/c1dcore^2; 
c1lmult26*exp(c1deltad) - c1lmult3(+1)*nbeta - (c1chi0*exp(c1deltad)*exp(c1y)^(c1chi + 1))/(exp(c1z)^c1chi*(c1chi + 1)); 
c1lmult3 - (c1lmult26*c1xip*exp(c1deltadlag))/(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup); 
-(c2dcore*c1lmult48*exp(c1dnxf))/c1dcore; 
c1lmult28*exp(c1g) - c1lmult27*exp(c1g); 
c1lmult24*exp(c1gp) + c1lmult22*exp(-c1gp)*exp(c1hp) - (c1beta*c1lmult24(-1)*c1xip*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^c1sigma); 
c1lmult23*exp(c1hp) - c1lmult22*exp(-c1gp)*exp(c1hp) - (c1beta*c1lmult23(-1)*c1xip*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)); 
(c1omegamc*c1lmult20*c1rhoc*exp(-c1mc)*exp(c1c)*(c1omegamc*exp(-c1mc)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - c1omegamc^(c1rhoc/(c1rhoc + 1))*c1lmult21*exp(c1mc)*exp(c1mc)^(1/(c1rhoc + 1) - 1)*(c1omegac^(c1rhoc/(c1rhoc + 1))*exp(c1cd)^(1/(c1rhoc + 1)) + c1omegamc^(c1rhoc/(c1rhoc + 1))*exp(c1mc)^(1/(c1rhoc + 1)))^c1rhoc - c1lmult41*c1relc2*exp(c1mc); 
c1lmult30*exp(-c1ngdplag)*exp(c1ngdp) - c1lmult4(+1)*nbeta; 
c1lmult4 - c1lmult30*exp(-c1ngdplag)*exp(c1ngdp); 
- c1lmult5(+1)*nbeta - c1lmult31*exp(-c1pcorelag)*exp(c1pcore); 
c1lmult5 + c1lmult31*exp(-c1pcorelag)*exp(c1pcore); 
(c1pistar*c1lmult25*c1xip)/(c1nup*c1pid^2*(c1pistar/c1pid)^(1/c1nup + 1)) - c1lmult30*exp(-c1ylag)*exp(c1y) - c1lmult29*exp(-c1rpcpdlag)*exp(c1rpcpd) + (c1beta*c1lmult18(-1)*exp(-c1rpcpd)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid^2*nbeta*exp(c1c)^c1sigma) - (c1pistar*c1lmult26*c1xip*exp(c1deltadlag)*(c1chi + 1)*(c1nup + 1))/(c1nup*c1pid^2*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)) - (c1beta*c1pistar*c1lmult24(-1)*c1xip*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*((c1nup + 1)/c1nup - 1))/(c1pid^2*nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^((c1nup + 1)/c1nup)) - (c1beta*c1pistar*c1lmult23(-1)*c1xip*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1chi + 1)*(c1nup + 1))/(c1nup*c1pid^2*nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)); 
c1lmult22*exp(c1pstar)*exp(c1pstar)^((c1chi*(c1nup + 1))/c1nup)*((c1chi*(c1nup + 1))/c1nup + 1) + (c1lmult25*exp(c1pstar)*(c1xip - 1))/(c1nup*exp(c1pstar)^(1/c1nup + 1)) - (c1lmult26*exp(c1pstar)*(c1chi + 1)*(c1nup + 1)*(c1xip - 1))/(c1nup*exp(c1pstar)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)); 
c1lmult47*exp(c1rer) - c1lmult6(+1)*nbeta - c1lmult34*exp(-c1rer)*exp(-c1rpcpd) + c1lmult20*exp(-c2rpcpd)*exp(c1rer) + c1lmult48*exp(-c1rerlag)*exp(c1rer) + c1lambdaqss*c1lmult46*c1rerss*c1rpcpdss*exp(-c1rer)*exp(c1c)^c1sigma; 
c1lmult6 - c1lmult48*exp(-c1rerlag)*exp(c1rer); 
- c1lmult7(+1)*nbeta - c1lmult18/(c1rn + 1)^2; 
c1lmult7; 
c1lmult19*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1)) - c1lmult23*((c1chi0*exp(c1rpcpd)*exp(c1y)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1beta*c1xip*exp(-c1rpcpd(+1))*exp(c1hp(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma)/(exp(c1c(+1))^c1sigma*(c1pistar/c1pid(+1))^(((c1chi + 1)*(c1nup + 1))/c1nup))) - c1lmult34*exp(-c1rer)*exp(-c1rpcpd) - c1lmult8(+1)*nbeta - c1pid*c1lmult29*exp(-c1rpcpdlag)*exp(c1rpcpd) - (c1beta*c1lmult18*exp(-c1rpcpd(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma)/(c1pid(+1)*exp(c1c(+1))^c1sigma) + (c1beta*c1lmult18(-1)*exp(-c1rpcpd)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid*nbeta*exp(c1c)^c1sigma) - (c1beta*c1lmult24*c1xip*exp(-c1rpcpd(+1))*exp(c1gp(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma*(c1pistar/c1pid(+1))^(1 - (c1nup + 1)/c1nup))/exp(c1c(+1))^c1sigma + (c1beta*c1lmult23(-1)*c1xip*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)) + (c1beta*c1lmult24(-1)*c1xip*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^c1sigma); 
c1lmult8 + c1pid*c1lmult29*exp(-c1rpcpdlag)*exp(c1rpcpd); 
c1lmult27*exp(c1y) - c1lmult23*((c1chi0*exp(c1rpcpd)*exp(c1y)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1chi*c1chi0*exp(2*c1y)*exp(-c1z)*exp(c1rpcpd)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^(c1chi - 1)*(c1nup + 1))/c1nup) - c1lmult9(+1)*nbeta - c1pid*c1lmult30*exp(-c1ylag)*exp(c1y) - (c1lmult24*exp(c1y)*(c1taup*exp(c1taupvar) + 1))/c1nup - c1lmult28*c1sharegy*exp(c1shockgy)*exp(c1y) - (c1chi0*exp(c1deltad)*exp(c1y)*exp(c1y)^c1chi)/exp(c1z)^c1chi; 
c1lmult9 + c1pid*c1lmult30*exp(-c1ylag)*exp(c1y); 
c1lmult35*exp(c2c) - c1lmult37*((c2chi0*c2sigma*exp(c2c)*exp(c2rpcpd)*exp(c2y)*exp(c2c)^(c2sigma - 1)*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2beta*c2sigma*c2xip*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2hp(+1))*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1))/(exp(c2c(+1))^c2sigma*(c2pistar/c2pid(+1))^(((c2chi + 1)*(c2nup + 1))/c2nup))) + c2lambdaqss*c1lmult46*c2rpcpdss*c2sigma*exp(c2c)*exp(c2c)^(c2sigma - 1) - (c2omegamc*c1lmult34*c2rhoc*exp(-c2mc)*exp(c2c)*(c2omegamc*exp(-c2mc)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) + (c2omegac*c1lmult33*c2rhoc*exp(-c2cd)*exp(c2c)*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) - (c2beta*c1lmult32*c2sigma*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1))/(c2pid(+1)*exp(c2c(+1))^c2sigma) + (c2beta*c1lmult32(-1)*c2sigma*exp(-c2rpcpd)*exp(c2c)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid*nbeta*exp(c2c)^(c2sigma + 1)) - (c2beta*c1lmult38*c2sigma*c2xip*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2gp(+1))*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1)*(c2pistar/c2pid(+1))^(1 - (c2nup + 1)/c2nup))/exp(c2c(+1))^c2sigma + (c2beta*c1lmult38(-1)*c2sigma*c2xip*exp(-c2rpcpd)*exp(c2c)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^(c2sigma + 1)) + (c2beta*c1lmult37(-1)*c2sigma*c2xip*exp(-c2rpcpd)*exp(c2c)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^(c2sigma + 1)*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)); 
- c1lmult41*exp(c2cd) - c2omegac^(c2rhoc/(c2rhoc + 1))*c1lmult35*exp(c2cd)*exp(c2cd)^(1/(c2rhoc + 1) - 1)*(c2omegac^(c2rhoc/(c2rhoc + 1))*exp(c2cd)^(1/(c2rhoc + 1)) + c2omegamc^(c2rhoc/(c2rhoc + 1))*exp(c2mc)^(1/(c2rhoc + 1)))^c2rhoc - (c2omegac*c1lmult33*c2rhoc*exp(-c2cd)*exp(c2c)*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1); 
c1lmult43 + c1lmult45 - (c1lmult48*exp(c1dnxf))/c1dcore + (c1dcore*c1lmult49*exp(c2dnxf))/c2dcore^2; 
c1lmult40*exp(c2deltad) - c1lmult10(+1)*nbeta; 
c1lmult10 - (c1lmult40*c2xip*exp(c2deltadlag))/(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup); 
- c1lmult2 - (c1dcore*c1lmult49*exp(c2dnxf))/c2dcore; 
c1lmult42*exp(c2g) - c1lmult41*exp(c2g); 
c1lmult38*exp(c2gp) + c1lmult36*exp(-c2gp)*exp(c2hp) - (c2beta*c1lmult38(-1)*c2xip*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^c2sigma); 
c1lmult37*exp(c2hp) - c1lmult36*exp(-c2gp)*exp(c2hp) - (c2beta*c1lmult37(-1)*c2xip*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)); 
(c2omegamc*c1lmult34*c2rhoc*exp(-c2mc)*exp(c2c)*(c2omegamc*exp(-c2mc)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) - c2omegamc^(c2rhoc/(c2rhoc + 1))*c1lmult35*exp(c2mc)*exp(c2mc)^(1/(c2rhoc + 1) - 1)*(c2omegac^(c2rhoc/(c2rhoc + 1))*exp(c2cd)^(1/(c2rhoc + 1)) + c2omegamc^(c2rhoc/(c2rhoc + 1))*exp(c2mc)^(1/(c2rhoc + 1)))^c2rhoc - (c1lmult27*exp(c2mc))/c1relc2; 
c1lmult44*exp(-c2ngdplag)*exp(c2ngdp) - c1lmult11(+1)*nbeta; 
c1lmult11 - c1lmult44*exp(-c2ngdplag)*exp(c2ngdp); 
- c1lmult12(+1)*nbeta - c1lmult45*exp(-c2pcorelag)*exp(c2pcore); 
c1lmult12 + c1lmult45*exp(-c2pcorelag)*exp(c2pcore); 
(c2pistar*c1lmult39*c2xip)/(c2nup*c2pid^2*(c2pistar/c2pid)^(1/c2nup + 1)) - c1lmult44*exp(-c2ylag)*exp(c2y) - c1lmult43*exp(-c2rpcpdlag)*exp(c2rpcpd) + (c2beta*c1lmult32(-1)*exp(-c2rpcpd)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid^2*nbeta*exp(c2c)^c2sigma) - (c2pistar*c1lmult40*c2xip*exp(c2deltadlag)*(c2chi + 1)*(c2nup + 1))/(c2nup*c2pid^2*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)) - (c2beta*c2pistar*c1lmult38(-1)*c2xip*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*((c2nup + 1)/c2nup - 1))/(c2pid^2*nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^((c2nup + 1)/c2nup)) - (c2beta*c2pistar*c1lmult37(-1)*c2xip*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2chi + 1)*(c2nup + 1))/(c2nup*c2pid^2*nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)); 
c1lmult36*exp(c2pstar)*exp(c2pstar)^((c2chi*(c2nup + 1))/c2nup)*((c2chi*(c2nup + 1))/c2nup + 1) + (c1lmult39*exp(c2pstar)*(c2xip - 1))/(c2nup*exp(c2pstar)^(1/c2nup + 1)) - (c1lmult40*exp(c2pstar)*(c2chi + 1)*(c2nup + 1)*(c2xip - 1))/(c2nup*exp(c2pstar)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)); 
c1lmult47*exp(-c2rer) - c1lmult13(+1)*nbeta + c1lmult49*exp(-c2rerlag)*exp(c2rer); 
c1lmult13 - c1lmult49*exp(-c2rerlag)*exp(c2rer); 
- c1lmult14(+1)*nbeta - c1lmult32/(c2rn + 1)^2; 
c1lmult14; 
c1lmult33*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1)) - c1lmult37*((c2chi0*exp(c2rpcpd)*exp(c2y)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2beta*c2xip*exp(-c2rpcpd(+1))*exp(c2hp(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma)/(exp(c2c(+1))^c2sigma*(c2pistar/c2pid(+1))^(((c2chi + 1)*(c2nup + 1))/c2nup))) - c1lmult15(+1)*nbeta - c1lmult20*exp(-c2rpcpd)*exp(c1rer) - c2pid*c1lmult43*exp(-c2rpcpdlag)*exp(c2rpcpd) - (c2beta*c1lmult32*exp(-c2rpcpd(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma)/(c2pid(+1)*exp(c2c(+1))^c2sigma) + (c2beta*c1lmult32(-1)*exp(-c2rpcpd)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid*nbeta*exp(c2c)^c2sigma) - (c2beta*c1lmult38*c2xip*exp(-c2rpcpd(+1))*exp(c2gp(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma*(c2pistar/c2pid(+1))^(1 - (c2nup + 1)/c2nup))/exp(c2c(+1))^c2sigma + (c2beta*c1lmult37(-1)*c2xip*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)) + (c2beta*c1lmult38(-1)*c2xip*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^c2sigma); 
c1lmult15 + c2pid*c1lmult43*exp(-c2rpcpdlag)*exp(c2rpcpd); 
c1lmult41*exp(c2y) - c1lmult37*((c2chi0*exp(c2rpcpd)*exp(c2y)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2chi*c2chi0*exp(2*c2y)*exp(-c2z)*exp(c2rpcpd)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^(c2chi - 1)*(c2nup + 1))/c2nup) - c1lmult16(+1)*nbeta - c2pid*c1lmult44*exp(-c2ylag)*exp(c2y) - (c1lmult38*exp(c2y)*(c2taup*exp(c2taupvar) + 1))/c2nup - c1lmult42*c2sharegy*exp(c2shockgy)*exp(c2y); 
c1lmult16 + c2pid*c1lmult44*exp(-c2ylag)*exp(c2y); 
c1lmult1; 
c1lmult17 - (c1beta*c1lmult17(-1))/nbeta; 
 
// Policymaker's First-Order Conditions for Country 2 
c2lmult21*exp(c1c) - c2lmult23*((c1chi0*c1sigma*exp(c1c)*exp(c1rpcpd)*exp(c1y)*exp(c1c)^(c1sigma - 1)*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1beta*c1sigma*c1xip*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1hp(+1))*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1))/(exp(c1c(+1))^c1sigma*(c1pistar/c1pid(+1))^(((c1chi + 1)*(c1nup + 1))/c1nup))) - (c2lmult17*exp(c1c))/exp(c1c)^c1sigma - (c1omegamc*c1rhoc*c2lmult20*exp(-c1mc)*exp(c1c)*(c1omegamc*exp(-c1mc)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - c1lambdaqss*c1rerss*c1rpcpdss*c1sigma*c2lmult46*exp(-c1rer)*exp(c1c)*exp(c1c)^(c1sigma - 1) + (c1omegac*c1rhoc*c2lmult19*exp(-c1cd)*exp(c1c)*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - (c1beta*c1sigma*c2lmult18*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1))/(c1pid(+1)*exp(c1c(+1))^c1sigma) + (c1beta*c1sigma*c2lmult18(-1)*exp(-c1rpcpd)*exp(c1c)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid*nbeta*exp(c1c)^(c1sigma + 1)) - (c1beta*c1sigma*c2lmult24*c1xip*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1gp(+1))*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1)*(c1pistar/c1pid(+1))^(1 - (c1nup + 1)/c1nup))/exp(c1c(+1))^c1sigma + (c1beta*c1sigma*c2lmult24(-1)*c1xip*exp(-c1rpcpd)*exp(c1c)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^(c1sigma + 1)) + (c1beta*c1sigma*c2lmult23(-1)*c1xip*exp(-c1rpcpd)*exp(c1c)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^(c1sigma + 1)*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)); 
- c2lmult27*exp(c1cd) - c1omegac^(c1rhoc/(c1rhoc + 1))*c2lmult21*exp(c1cd)*exp(c1cd)^(1/(c1rhoc + 1) - 1)*(c1omegac^(c1rhoc/(c1rhoc + 1))*exp(c1cd)^(1/(c1rhoc + 1)) + c1omegamc^(c1rhoc/(c1rhoc + 1))*exp(c1mc)^(1/(c1rhoc + 1)))^c1rhoc - (c1omegac*c1rhoc*c2lmult19*exp(-c1cd)*exp(c1c)*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1); 
c2lmult29 - c2lmult1 + c2lmult31 - (c2lmult49*exp(c2dnxf))/c2dcore + (c2dcore*c2lmult48*exp(c1dnxf))/c1dcore^2; 
c2lmult26*exp(c1deltad) - c2lmult3(+1)*nbeta; 
c2lmult3 - (c2lmult26*c1xip*exp(c1deltadlag))/(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup); 
-(c2dcore*c2lmult48*exp(c1dnxf))/c1dcore; 
c2lmult28*exp(c1g) - c2lmult27*exp(c1g); 
c2lmult24*exp(c1gp) + c2lmult22*exp(-c1gp)*exp(c1hp) - (c1beta*c2lmult24(-1)*c1xip*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^c1sigma); 
c2lmult23*exp(c1hp) - c2lmult22*exp(-c1gp)*exp(c1hp) - (c1beta*c2lmult23(-1)*c1xip*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)); 
(c1omegamc*c1rhoc*c2lmult20*exp(-c1mc)*exp(c1c)*(c1omegamc*exp(-c1mc)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - c1omegamc^(c1rhoc/(c1rhoc + 1))*c2lmult21*exp(c1mc)*exp(c1mc)^(1/(c1rhoc + 1) - 1)*(c1omegac^(c1rhoc/(c1rhoc + 1))*exp(c1cd)^(1/(c1rhoc + 1)) + c1omegamc^(c1rhoc/(c1rhoc + 1))*exp(c1mc)^(1/(c1rhoc + 1)))^c1rhoc - c1relc2*c2lmult41*exp(c1mc); 
c2lmult30*exp(-c1ngdplag)*exp(c1ngdp) - c2lmult4(+1)*nbeta; 
c2lmult4 - c2lmult30*exp(-c1ngdplag)*exp(c1ngdp); 
- c2lmult5(+1)*nbeta - c2lmult31*exp(-c1pcorelag)*exp(c1pcore); 
c2lmult5 + c2lmult31*exp(-c1pcorelag)*exp(c1pcore); 
(c1pistar*c2lmult25*c1xip)/(c1nup*c1pid^2*(c1pistar/c1pid)^(1/c1nup + 1)) - c2lmult30*exp(-c1ylag)*exp(c1y) - c2lmult29*exp(-c1rpcpdlag)*exp(c1rpcpd) + (c1beta*c2lmult18(-1)*exp(-c1rpcpd)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid^2*nbeta*exp(c1c)^c1sigma) - (c1pistar*c2lmult26*c1xip*exp(c1deltadlag)*(c1chi + 1)*(c1nup + 1))/(c1nup*c1pid^2*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)) - (c1beta*c1pistar*c2lmult24(-1)*c1xip*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*((c1nup + 1)/c1nup - 1))/(c1pid^2*nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^((c1nup + 1)/c1nup)) - (c1beta*c1pistar*c2lmult23(-1)*c1xip*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1chi + 1)*(c1nup + 1))/(c1nup*c1pid^2*nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)); 
c2lmult22*exp(c1pstar)*exp(c1pstar)^((c1chi*(c1nup + 1))/c1nup)*((c1chi*(c1nup + 1))/c1nup + 1) + (c2lmult25*exp(c1pstar)*(c1xip - 1))/(c1nup*exp(c1pstar)^(1/c1nup + 1)) - (c2lmult26*exp(c1pstar)*(c1chi + 1)*(c1nup + 1)*(c1xip - 1))/(c1nup*exp(c1pstar)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)); 
c2lmult47*exp(c1rer) - c2lmult6(+1)*nbeta - c2lmult34*exp(-c1rer)*exp(-c1rpcpd) + c2lmult20*exp(-c2rpcpd)*exp(c1rer) + c2lmult48*exp(-c1rerlag)*exp(c1rer) + c1lambdaqss*c1rerss*c1rpcpdss*c2lmult46*exp(-c1rer)*exp(c1c)^c1sigma; 
c2lmult6 - c2lmult48*exp(-c1rerlag)*exp(c1rer); 
- c2lmult7(+1)*nbeta - c2lmult18/(c1rn + 1)^2; 
c2lmult7; 
c2lmult19*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1)) - c2lmult23*((c1chi0*exp(c1rpcpd)*exp(c1y)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1beta*c1xip*exp(-c1rpcpd(+1))*exp(c1hp(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma)/(exp(c1c(+1))^c1sigma*(c1pistar/c1pid(+1))^(((c1chi + 1)*(c1nup + 1))/c1nup))) - c2lmult34*exp(-c1rer)*exp(-c1rpcpd) - c2lmult8(+1)*nbeta - c1pid*c2lmult29*exp(-c1rpcpdlag)*exp(c1rpcpd) - (c1beta*c2lmult18*exp(-c1rpcpd(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma)/(c1pid(+1)*exp(c1c(+1))^c1sigma) + (c1beta*c2lmult18(-1)*exp(-c1rpcpd)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid*nbeta*exp(c1c)^c1sigma) - (c1beta*c2lmult24*c1xip*exp(-c1rpcpd(+1))*exp(c1gp(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma*(c1pistar/c1pid(+1))^(1 - (c1nup + 1)/c1nup))/exp(c1c(+1))^c1sigma + (c1beta*c2lmult23(-1)*c1xip*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)) + (c1beta*c2lmult24(-1)*c1xip*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^c1sigma); 
c2lmult8 + c1pid*c2lmult29*exp(-c1rpcpdlag)*exp(c1rpcpd); 
c2lmult27*exp(c1y) - c2lmult23*((c1chi0*exp(c1rpcpd)*exp(c1y)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1chi*c1chi0*exp(2*c1y)*exp(-c1z)*exp(c1rpcpd)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^(c1chi - 1)*(c1nup + 1))/c1nup) - c2lmult9(+1)*nbeta - c1pid*c2lmult30*exp(-c1ylag)*exp(c1y) - (c2lmult24*exp(c1y)*(c1taup*exp(c1taupvar) + 1))/c1nup - c1sharegy*c2lmult28*exp(c1shockgy)*exp(c1y); 
c2lmult9 + c1pid*c2lmult30*exp(-c1ylag)*exp(c1y); 
exp(c2c)/exp(c2c)^c2sigma + c2lmult35*exp(c2c) - c2lmult37*((c2chi0*c2sigma*exp(c2c)*exp(c2rpcpd)*exp(c2y)*exp(c2c)^(c2sigma - 1)*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2beta*c2sigma*c2xip*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2hp(+1))*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1))/(exp(c2c(+1))^c2sigma*(c2pistar/c2pid(+1))^(((c2chi + 1)*(c2nup + 1))/c2nup))) + c2lambdaqss*c2rpcpdss*c2sigma*c2lmult46*exp(c2c)*exp(c2c)^(c2sigma - 1) - (c2omegamc*c2rhoc*c2lmult34*exp(-c2mc)*exp(c2c)*(c2omegamc*exp(-c2mc)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) + (c2omegac*c2rhoc*c2lmult33*exp(-c2cd)*exp(c2c)*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) - (c2beta*c2sigma*c2lmult32*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1))/(c2pid(+1)*exp(c2c(+1))^c2sigma) + (c2beta*c2sigma*c2lmult32(-1)*exp(-c2rpcpd)*exp(c2c)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid*nbeta*exp(c2c)^(c2sigma + 1)) - (c2beta*c2sigma*c2lmult38*c2xip*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2gp(+1))*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1)*(c2pistar/c2pid(+1))^(1 - (c2nup + 1)/c2nup))/exp(c2c(+1))^c2sigma + (c2beta*c2sigma*c2lmult38(-1)*c2xip*exp(-c2rpcpd)*exp(c2c)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^(c2sigma + 1)) + (c2beta*c2sigma*c2lmult37(-1)*c2xip*exp(-c2rpcpd)*exp(c2c)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^(c2sigma + 1)*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)); 
- c2lmult41*exp(c2cd) - c2omegac^(c2rhoc/(c2rhoc + 1))*c2lmult35*exp(c2cd)*exp(c2cd)^(1/(c2rhoc + 1) - 1)*(c2omegac^(c2rhoc/(c2rhoc + 1))*exp(c2cd)^(1/(c2rhoc + 1)) + c2omegamc^(c2rhoc/(c2rhoc + 1))*exp(c2mc)^(1/(c2rhoc + 1)))^c2rhoc - (c2omegac*c2rhoc*c2lmult33*exp(-c2cd)*exp(c2c)*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1); 
c2lmult43 + c2lmult45 - (c2lmult48*exp(c1dnxf))/c1dcore + (c1dcore*c2lmult49*exp(c2dnxf))/c2dcore^2; 
c2lmult40*exp(c2deltad) - c2lmult10(+1)*nbeta - (c2chi0*exp(c2deltad)*exp(c2y)^(c2chi + 1))/(exp(c2z)^c2chi*(c2chi + 1)); 
c2lmult10 - (c2lmult40*c2xip*exp(c2deltadlag))/(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup); 
- c2lmult2 - (c1dcore*c2lmult49*exp(c2dnxf))/c2dcore; 
c2lmult42*exp(c2g) - c2lmult41*exp(c2g); 
c2lmult38*exp(c2gp) + c2lmult36*exp(-c2gp)*exp(c2hp) - (c2beta*c2lmult38(-1)*c2xip*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^c2sigma); 
c2lmult37*exp(c2hp) - c2lmult36*exp(-c2gp)*exp(c2hp) - (c2beta*c2lmult37(-1)*c2xip*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)); 
(c2omegamc*c2rhoc*c2lmult34*exp(-c2mc)*exp(c2c)*(c2omegamc*exp(-c2mc)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) - c2omegamc^(c2rhoc/(c2rhoc + 1))*c2lmult35*exp(c2mc)*exp(c2mc)^(1/(c2rhoc + 1) - 1)*(c2omegac^(c2rhoc/(c2rhoc + 1))*exp(c2cd)^(1/(c2rhoc + 1)) + c2omegamc^(c2rhoc/(c2rhoc + 1))*exp(c2mc)^(1/(c2rhoc + 1)))^c2rhoc - (c2lmult27*exp(c2mc))/c1relc2; 
c2lmult44*exp(-c2ngdplag)*exp(c2ngdp) - c2lmult11(+1)*nbeta; 
c2lmult11 - c2lmult44*exp(-c2ngdplag)*exp(c2ngdp); 
- c2lmult12(+1)*nbeta - c2lmult45*exp(-c2pcorelag)*exp(c2pcore); 
c2lmult12 + c2lmult45*exp(-c2pcorelag)*exp(c2pcore); 
(c2pistar*c2lmult39*c2xip)/(c2nup*c2pid^2*(c2pistar/c2pid)^(1/c2nup + 1)) - c2lmult44*exp(-c2ylag)*exp(c2y) - c2lmult43*exp(-c2rpcpdlag)*exp(c2rpcpd) + (c2beta*c2lmult32(-1)*exp(-c2rpcpd)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid^2*nbeta*exp(c2c)^c2sigma) - (c2pistar*c2lmult40*c2xip*exp(c2deltadlag)*(c2chi + 1)*(c2nup + 1))/(c2nup*c2pid^2*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)) - (c2beta*c2pistar*c2lmult38(-1)*c2xip*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*((c2nup + 1)/c2nup - 1))/(c2pid^2*nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^((c2nup + 1)/c2nup)) - (c2beta*c2pistar*c2lmult37(-1)*c2xip*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2chi + 1)*(c2nup + 1))/(c2nup*c2pid^2*nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)); 
c2lmult36*exp(c2pstar)*exp(c2pstar)^((c2chi*(c2nup + 1))/c2nup)*((c2chi*(c2nup + 1))/c2nup + 1) + (c2lmult39*exp(c2pstar)*(c2xip - 1))/(c2nup*exp(c2pstar)^(1/c2nup + 1)) - (c2lmult40*exp(c2pstar)*(c2chi + 1)*(c2nup + 1)*(c2xip - 1))/(c2nup*exp(c2pstar)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)); 
c2lmult47*exp(-c2rer) - c2lmult13(+1)*nbeta + c2lmult49*exp(-c2rerlag)*exp(c2rer); 
c2lmult13 - c2lmult49*exp(-c2rerlag)*exp(c2rer); 
- c2lmult14(+1)*nbeta - c2lmult32/(c2rn + 1)^2; 
c2lmult14; 
c2lmult33*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1)) - c2lmult37*((c2chi0*exp(c2rpcpd)*exp(c2y)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2beta*c2xip*exp(-c2rpcpd(+1))*exp(c2hp(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma)/(exp(c2c(+1))^c2sigma*(c2pistar/c2pid(+1))^(((c2chi + 1)*(c2nup + 1))/c2nup))) - c2lmult15(+1)*nbeta - c2lmult20*exp(-c2rpcpd)*exp(c1rer) - c2pid*c2lmult43*exp(-c2rpcpdlag)*exp(c2rpcpd) - (c2beta*c2lmult32*exp(-c2rpcpd(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma)/(c2pid(+1)*exp(c2c(+1))^c2sigma) + (c2beta*c2lmult32(-1)*exp(-c2rpcpd)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid*nbeta*exp(c2c)^c2sigma) - (c2beta*c2lmult38*c2xip*exp(-c2rpcpd(+1))*exp(c2gp(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma*(c2pistar/c2pid(+1))^(1 - (c2nup + 1)/c2nup))/exp(c2c(+1))^c2sigma + (c2beta*c2lmult37(-1)*c2xip*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)) + (c2beta*c2lmult38(-1)*c2xip*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^c2sigma); 
c2lmult15 + c2pid*c2lmult43*exp(-c2rpcpdlag)*exp(c2rpcpd); 
c2lmult41*exp(c2y) - c2lmult37*((c2chi0*exp(c2rpcpd)*exp(c2y)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2chi*c2chi0*exp(2*c2y)*exp(-c2z)*exp(c2rpcpd)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^(c2chi - 1)*(c2nup + 1))/c2nup) - c2lmult16(+1)*nbeta - c2pid*c2lmult44*exp(-c2ylag)*exp(c2y) - (c2lmult38*exp(c2y)*(c2taup*exp(c2taupvar) + 1))/c2nup - c2sharegy*c2lmult42*exp(c2shockgy)*exp(c2y) - (c2chi0*exp(c2deltad)*exp(c2y)*exp(c2y)^c2chi)/exp(c2z)^c2chi; 
c2lmult16 + c2pid*c2lmult44*exp(-c2ylag)*exp(c2y); 
c2lmult2; 
c2lmult17 - (c1beta*c2lmult17(-1))/nbeta; 
 
// Welfcon1 
Welfcon1 = (exp(c1c))^(1-c1sigma)/(1-c1sigma) + c1beta*Welfcon1(+1); 
 
 
////////////////////////////////// 
// Home country bloc  
////////////////////////////////// 
 
// definition of nominal interest rate  
1/(1+(c1rn)) = c1beta*(((exp(c1c(+1)))^(-c1sigma)/exp(c1rpcpd(+1))))/(((exp(c1c))^(-c1sigma)/exp(c1rpcpd)))/c1pid(+1); 
 
// fonc domestic consumption good 
exp(c1rpcpd)*(c1omegac*exp(c1c)/exp(c1cd))^(c1rhoc/(1+c1rhoc)) = 1; 
 
// fonc imported good 
(exp(c1rer))/(exp(c2rpcpd))= (c1omegamc*exp(c1c)/exp(c1mc))^(c1rhoc/(1+c1rhoc)); 
 
// final consumption  
exp(c1c) = ((c1omegac)^(c1rhoc/(1+c1rhoc))*exp(c1cd)^(1/(1+c1rhoc))+(c1omegamc)^(c1rhoc/(1+c1rhoc))*(exp(c1mc))^(1/(1+c1rhoc)))^(1+c1rhoc); 
 
// definition of pstar 
(exp(c1pstar))^(1+(1+c1nup)/(c1nup)*c1chi) = (exp(c1hp))/(exp(c1gp)); 
 
// definition of hp 
(exp(c1hp)) = (1+(c1nup))/(c1nup) 
*c1chi0*(exp(c1y)/exp(c1z))^(c1chi)/((exp(c1c))^(-c1sigma)/exp(c1rpcpd))*exp(c1y) 
+ c1xip*c1beta*(((exp(c1c(+1)))^(-c1sigma)/exp(c1rpcpd(+1))))/(((exp(c1c))^(-c1sigma)/exp(c1rpcpd)))*((c1pistar)/(c1pid(+1)))^(-(1 
+(c1nup))/(c1nup)*(1+c1chi))*(exp(c1hp(+1))); 
 
// definition of gp 
(exp(c1gp)) = (1+c1taup*exp(c1taupvar))/(c1nup)*(exp(c1y))+c1xip*c1beta*(((exp(c1c(+1)))^(-c1sigma)/exp(c1rpcpd(+1))))/(((exp(c1c))^(-c1sigma)/exp(c1rpcpd)))*((c1pistar)/(c1pid(+1)))^(1 
-(1+(c1nup))/(c1nup))*(exp(c1gp(+1))); 
 
// price evolution 
(1-c1xip)*((exp(c1pstar)))^(-1/(c1nup))+c1xip*((c1pistar)/(c1pid))^(-1/(c1nup)) = 1; 
 
// evolution of price dispersion 
(exp(c1deltad)) = (1-c1xip)*((exp(c1pstar)))^(-(1+(c1nup))/(c1nup)*(1+c1chi)) 
+c1xip*((c1pistar)/(c1pid))^(-(1+(c1nup))/(c1nup)*(1+c1chi))*(exp(c1deltadlag)); 
 
// resource constraint goods 
exp(c1y) = exp(c1cd)+exp(c1g)+1/c1relc2*(exp(c2mc)); 
 
// government spending 
exp(c1g) = c1sharegy*exp(c1y)*exp(c1shockgy); 
 
// core inflation 
c1dcore = exp(c1rpcpd)/exp(c1rpcpdlag)*c1pid; 
 
// nominal gdp 
exp(c1ngdp)/exp(c1ngdplag) = c1pid*exp(c1y)/exp(c1ylag);  
 
// consumer price level 
c1dcore = exp(c1pcore)/exp(c1pcorelag); 
 
 
////////////////////////////////// 
// Foreign country bloc  
////////////////////////////////// 
 
// definition of nominal interest rate 
1/(1+(c2rn)) = c2beta*(((exp(c2c(+1)))^(-c2sigma)/exp(c2rpcpd(+1))))/(((exp(c2c))^(-c2sigma)/exp(c2rpcpd)))/c2pid(+1); 
 
// fonc domestic consumption good 
(exp(c2rpcpd))*(c2omegac*(exp(c2c))/(exp(c2cd)))^(c2rhoc/(1+c2rhoc)) = 1; 
 
// fonc imported good 
1/(exp(c1rer))/(exp(c1rpcpd)) = (c2omegamc*(exp(c2c))/(exp(c2mc)))^(c2rhoc/(1+c2rhoc)); 
 
// final consumption 
(exp(c2c)) = ((c2omegac)^(c2rhoc/(1+c2rhoc))*(exp(c2cd))^(1/(1+c2rhoc))+(c2omegamc)^(c2rhoc/(1+c2rhoc))*((exp(c2mc)))^(1/(1+c2rhoc)))^(1+c2rhoc); 
 
// definition of pstar 
(exp(c2pstar))^(1+(1+c2nup)/(c2nup)*c2chi) = (exp(c2hp))/(exp(c2gp)); 
 
// definition of hp 
(exp(c2hp)) = (1+(c2nup))/(c2nup) 
*c2chi0*(exp(c2y)/exp(c2z))^c2chi/((exp(c2c))^(-c2sigma)/exp(c2rpcpd))*exp(c2y) 
+ c2xip*c2beta*(((exp(c2c(+1)))^(-c2sigma)/exp(c2rpcpd(+1))))/(((exp(c2c))^(-c2sigma)/exp(c2rpcpd)))*((c2pistar)/(c2pid(+1)))^(-(1 
+(c2nup))/(c2nup)*(1+c2chi))*(exp(c2hp(+1))); 
 
// definition of gp 
(exp(c2gp)) = (1+c2taup*exp(c2taupvar))/(c2nup)*(exp(c2y))+c2xip*c2beta*(((exp(c2c(+1)))^(-c2sigma)/exp(c2rpcpd(+1))))/(((exp(c2c))^(-c2sigma)/exp(c2rpcpd)))*((c2pistar)/(c2pid(+1)))^(1 
-(1+(c2nup))/(c2nup))*(exp(c2gp(+1))); 
 
// price evolution 
(1-c2xip)*((exp(c2pstar)))^(-1/(c2nup))+c2xip*((c2pistar)/(c2pid))^(-1/(c2nup)) = 1; 
 
// evolution of price dispersion 
(exp(c2deltad)) = (1-c2xip)*((exp(c2pstar)))^(-(1+(c2nup))/(c2nup)*(1+c2chi)) 
+c2xip*((c2pistar)/(c2pid))^(-(1+(c2nup))/(c2nup)*(1+c2chi))*(exp(c2deltadlag)); 
 
// resource constraint goods 
(exp(c2y)) = (exp(c2cd))+(exp(c2g))+(c1relc2*(exp(c1mc))); 
 
// government spending 
(exp(c2g)) = c2sharegy*(exp(c2y))*(exp(c2shockgy)); 
 
// core inflation 
c2dcore = exp(c2rpcpd)/exp(c2rpcpdlag)*c2pid; 
 
// nominal gdp 
exp(c2ngdp)/exp(c2ngdplag) = c2pid*exp(c2y)/exp(c2ylag);  
 
// consumer price level 
c2dcore = exp(c2pcore)/exp(c2pcorelag); 
 
//////////////////////// 
// international links 
//////////////////////// 
 
// risk sharing  
c2lambdaqss/((exp(c2c))^(-c2sigma))*c2rpcpdss = c1rerss/(exp(c1rer))*c1lambdaqss/((exp(c1c))^(-c1sigma))*c1rpcpdss; 
 
// real exchange rate 
exp(c1rer) = 1/exp(c2rer); 
 
// nominal exchange rate 
exp(c1rer)/exp(c1rerlag) = exp(c1dnxf)*c2dcore/c1dcore; 
 
// nominal exchange rate 
exp(c2rer)/exp(c2rerlag) = exp(c2dnxf)*c1dcore/c2dcore; 
 
// Utility, country 1 
Util1 = (exp(c1c))^(1-c1sigma)/(1-c1sigma)-c1chi0*(exp(c1z))^(-c1chi)*(exp(c1y))^(1+c1chi)/(1+c1chi)*exp(c1deltad); 
 
// Utility, country 2 
Util2 = (exp(c2c))^(1-c2sigma)/(1-c2sigma)-c2chi0*(exp(c2z))^(-c2chi)*(exp(c2y))^(1+c2chi)/(1+c2chi)*exp(c2deltad); 
 
 
///////////////////////// 
// exogenous variables 
///////////////////////// 
 
c1shockgy = c1rhogy*c1shockgy(-1) + c1sigmagy*c1shockgyerr; 
 
c1z = c1rhoz*c1z(-1) + c1sigmaz*c1zerr; 
 
c1taupvar = c1rhotaupvar*c1taupvar(-1)+c1sigmataupvarerr*c1taupvarerr; 
 
c2shockgy = c2rhogy*c2shockgy(-1) + c2sigmagy*c2shockgyerr; 
 
c2z = c2rhoz*c2z(-1) + c2sigmaz*c2zerr; 
 
c2taupvar = c2rhotaupvar*c2taupvar(-1)+c2sigmataupvarerr*c2taupvarerr; 
 
end; 
 
 
shocks; 
var c1shockgyerr = 0;  
var c1zerr = 1;  
var c2shockgyerr = 0;  
var c2zerr = 1; 
var c2taupvarerr = 1; 
var c1taupvarerr = 1; 
end; 

 
steady; 
 
check; 
 
stoch_simul(order=2,nocorr,noprint,irf=0); 
