// Endogenous variables 
var 
shadow_Welfcorrection
Util, 
Welf, 
instr1, 
instr2, 
Util1, 
Util2, 
c1c, 
c1cd, 
c1mc, 
c1y, 
c1g, 
c1rpcpd, 
c1pid, 
c1hp, 
c1gp, 
c1pstar, 
c1deltad, 
c1rn, 
c1rer 
c1dcore, 
c2c, 
c2cd, 
c2mc, 
c2y, 
c2g, 
c2rpcpd, 
c2pid, 
c2hp, 
c2gp, 
c2pstar, 
c2deltad, 
c2rn, 
c2dcore, 
Welfcon1,  
c1deltadlag,  
c1rnlag,  
c1rpcpdlag,  
c2deltadlag,  
c2rnlag,  
c2rpcpdlag,  
c1deltadlag2,  
c1rnlag2,  
c1rpcpdlag2,  
c2deltadlag2,  
c2rnlag2,  
c2rpcpdlag2;  
 
// Exogenous variables  
var c1shockgy, 
c1z, 
c1taupvar, 
c2shockgy, 
c2z, 
c2taupvar; 
 
varexo  c1shockgyerr 
c1zerr 
c2shockgyerr 
c2zerr 
c2taupvarerr 
c1taupvarerr 
c1monerr 
c2monerr; 
 
parameters   
omega_welf1, 
omega_welf2, 
nbeta,c1sigma, 
c1beta, 
c1rhoc,              
c1sharegy,           
c1rhogy,             
c1sigmagy,   
c1rhoz,            
c1sigmaz,        
c2sigma,             
c2beta,              
c2rhoc,              
c2sharegy,           
c2rhogy,             
c2sigmagy,  
c2rhoz,            
c2sigmaz,        
c2rhotaupvar,      
c2sigmataupvarerr, 
c1rhotaupvar,      
c1sigmataupvarerr, 
c2chi,               
c1chi,               
c2nup,            
c1nup,            
c2xip,               
c1xip,               
c1chi0, 
c1omegac, 
c1omegamc, 
c1relc2, 
c1pistar, 
c1taup, 
c2chi0, 
c2omegac, 
c2omegamc, 
c2pistar, 
c2taup, 
c1rnss, 
c2rnss, 
c1gamrn,                       
c1gamdpc,                         
c2gamrn,             
c2gamdpc, 
c2lambdaqss, 
c2rpcpdss, 
c1rerss, 
c1lambdaqss, 
c1rpcpdss,
shadow_c1rn_weight; 
 
var lmult1,  lmult2,  lmult3,  lmult4,  lmult5,  lmult6,  lmult7,   
    lmult8,  lmult9,  lmult10,  lmult11,  lmult12,  lmult13,  lmult14,   
    lmult15,  lmult16,  lmult17,  lmult18,  lmult19,  lmult20,  lmult21,   
    lmult22,  lmult23,  lmult24,  lmult25,  lmult26,  lmult27,  lmult28,   
    lmult29,  lmult30,  lmult31,  lmult32,  lmult33,  lmult34,  lmult35,   
    lmult36,  lmult37,  lmult38,  lmult39,  lmult40,  lmult41,  lmult42,   
    Welf1,  Welf2; 
  
var Welfcorrection; 
  
var shadow_Util       ,  
shadow_Welf       ,  
shadow_instr1     ,  
shadow_instr2     ,  
shadow_Util1      ,  
shadow_Util2      ,  
shadow_c1c        ,  
shadow_c1cd       ,  
shadow_c1mc       ,  
shadow_c1y        ,  
shadow_c1g        ,  
shadow_c1rpcpd    ,  
shadow_c1pid      ,  
shadow_c1hp       ,  
shadow_c1gp       ,  
shadow_c1pstar    ,  
shadow_c1deltad   ,  
shadow_c1rn       ,  
shadow_c1rer      ,  
shadow_c1dcore    ,  
shadow_c2c        ,  
shadow_c2cd       ,  
shadow_c2mc       ,  
shadow_c2y        ,  
shadow_c2g        ,  
shadow_c2rpcpd    ,  
shadow_c2pid      ,  
shadow_c2hp       ,  
shadow_c2gp       ,  
shadow_c2pstar    ,  
shadow_c2deltad   ,  
shadow_c2rn       ,  
shadow_c2dcore    ,  
shadow_Welfcon1   ,  
shadow_c1deltadlag,  
shadow_c1rnlag    ,  
shadow_c1rpcpdlag ,  
shadow_c2deltadlag,  
shadow_c2rnlag    ,  
shadow_c2rpcpdlag ,  
shadow_c1shockgy  ,  
shadow_c1z        ,  
shadow_c1taupvar  ,  
shadow_c2shockgy  ,  
shadow_c2z        ,  
shadow_c2taupvar  ,  
shadow_Welf1      ,  
shadow_Welf2      ;  
 
// SHADOW BLOCK 
 
model; 
 
////////////////////////////////// 
// Utility and Welfare bloc 
////////////////////////////////// 
 
// Utility, aggregate  
shadow_Util = omega_welf1*shadow_Util1+omega_welf2*shadow_Util2; 
 
// Welfare, aggregate  
shadow_Welf = shadow_Util + nbeta*shadow_Welf(1); 
 
//// Welfare, agent 1 
shadow_Welf1 = shadow_Util1 + nbeta*shadow_Welf1(1); 
 
//// Welfare, agent 2 
shadow_Welf2 = shadow_Util2+ nbeta*shadow_Welf2(1); 
 
// Policy instrument, agent 1 
shadow_instr1 = shadow_c1pid; 
 
// Policy instrument, agent 2 
shadow_instr2 = shadow_c2pid; 
 
shadow_c1deltadlag =shadow_c1deltad(-1);  
shadow_c1rnlag =shadow_c1rn(-1);  
shadow_c1rpcpdlag =shadow_c1rpcpd(-1);  
shadow_c2deltadlag =shadow_c2deltad(-1);  
shadow_c2rnlag =shadow_c2rn(-1);  
shadow_c2rpcpdlag =shadow_c2rpcpd(-1);  
 
////////////////////////////////// 
// Monetary policy bloc 
////////////////////////////////// 
  
// Policy Rule, country 1 
// shadow_c1rn = (1+c1rnss)*(((1+shadow_c1rnlag)/(1+c1rnss))^c1gamrn*((shadow_c1pid/c1pistar)*(shadow_c1pid/c1pistar)^c1gamdpc)^(1-c1gamrn))*(1+c1monerr)-1; 
shadow_c1pid = shadow_c1rn_weight + (1-shadow_c1rn_weight)*c1pid;

// Policy Rule, country 2 
//shadow_c2rn = (1+c2rnss)*(((1+shadow_c2rnlag)/(1+c2rnss))^c2gamrn*((shadow_c2pid/c2pistar)*(shadow_c2pid/c2pistar)^c2gamdpc)^(1-c2gamrn))*(1+c2monerr)-1; 
shadow_c2pid = c2pid;

// shadow_Welfcon1 
shadow_Welfcon1 = (exp(shadow_c1c))^(1-c1sigma)/(1-c1sigma) + c1beta*shadow_Welfcon1(+1); 
 
 
////////////////////////////////// 
// Home country bloc  
////////////////////////////////// 
 
// definition of nominal interest rate  
1/(1+(shadow_c1rn)) = c1beta*(((exp(shadow_c1c(+1)))^(-c1sigma)/exp(shadow_c1rpcpd(+1))))/(((exp(shadow_c1c))^(-c1sigma)/exp(shadow_c1rpcpd)))/shadow_c1pid(+1); 
 
// fonc domestic consumption good 
exp(shadow_c1rpcpd)*(c1omegac*exp(shadow_c1c)/exp(shadow_c1cd))^(c1rhoc/(1+c1rhoc)) = 1; 
 
// fonc imported good 
(exp(shadow_c1rer))/(exp(shadow_c2rpcpd))= (c1omegamc*exp(shadow_c1c)/exp(shadow_c1mc))^(c1rhoc/(1+c1rhoc)); 
 
// final consumption  
exp(shadow_c1c) = ((c1omegac)^(c1rhoc/(1+c1rhoc))*exp(shadow_c1cd)^(1/(1+c1rhoc))+(c1omegamc)^(c1rhoc/(1+c1rhoc))*(exp(shadow_c1mc))^(1/(1+c1rhoc)))^(1+c1rhoc); 
 
// definition of pstar 
(exp(shadow_c1pstar))^(1+(1+c1nup)/(c1nup)*c1chi) = (exp(shadow_c1hp))/(exp(shadow_c1gp)); 
 
// definition of hp 
(exp(shadow_c1hp)) = (1+(c1nup))/(c1nup) 
*c1chi0*(exp(shadow_c1y)/exp(shadow_c1z))^(c1chi)/((exp(shadow_c1c))^(-c1sigma)/exp(shadow_c1rpcpd))*exp(shadow_c1y) 
+ c1xip*c1beta*(((exp(shadow_c1c(+1)))^(-c1sigma)/exp(shadow_c1rpcpd(+1))))/(((exp(shadow_c1c))^(-c1sigma)/exp(shadow_c1rpcpd)))*((c1pistar)/(shadow_c1pid(+1)))^(-(1 
+(c1nup))/(c1nup)*(1+c1chi))*(exp(shadow_c1hp(+1))); 
 
// definition of gp 
(exp(shadow_c1gp)) = (1+c1taup*exp(shadow_c1taupvar))/(c1nup)*(exp(shadow_c1y))+c1xip*c1beta*(((exp(shadow_c1c(+1)))^(-c1sigma)/exp(shadow_c1rpcpd(+1))))/(((exp(shadow_c1c))^(-c1sigma)/exp(shadow_c1rpcpd)))*((c1pistar)/(shadow_c1pid(+1)))^(1 
-(1+(c1nup))/(c1nup))*(exp(shadow_c1gp(+1))); 
 
// price evolution 
(1-c1xip)*((exp(shadow_c1pstar)))^(-1/(c1nup))+c1xip*((c1pistar)/(shadow_c1pid))^(-1/(c1nup)) = 1; 
 
// evolution of price dispersion 
(exp(shadow_c1deltad)) = (1-c1xip)*((exp(shadow_c1pstar)))^(-(1+(c1nup))/(c1nup)*(1+c1chi)) 
+c1xip*((c1pistar)/(shadow_c1pid))^(-(1+(c1nup))/(c1nup)*(1+c1chi))*(exp(shadow_c1deltadlag)); 
 
// resource constraint goods 
exp(shadow_c1y) = exp(shadow_c1cd)+exp(shadow_c1g)+1/c1relc2*(exp(shadow_c2mc)); 
 
// government spending 
exp(shadow_c1g) = c1sharegy*exp(shadow_c1y)*exp(shadow_c1shockgy); 
 
// core inflation 
shadow_c1dcore = exp(shadow_c1rpcpd)/exp(shadow_c1rpcpdlag)*shadow_c1pid; 
 
////////////////////////////////// 
// Foreign country bloc  
////////////////////////////////// 
 
// definition of nominal interest rate 
1/(1+(shadow_c2rn)) = c2beta*(((exp(shadow_c2c(+1)))^(-c2sigma)/exp(shadow_c2rpcpd(+1))))/(((exp(shadow_c2c))^(-c2sigma)/exp(shadow_c2rpcpd)))/shadow_c2pid(+1); 
 
// fonc domestic consumption good 
(exp(shadow_c2rpcpd))*(c2omegac*(exp(shadow_c2c))/(exp(shadow_c2cd)))^(c2rhoc/(1+c2rhoc)) = 1; 
 
// fonc imported good 
1/(exp(shadow_c1rer))/(exp(shadow_c1rpcpd)) = (c2omegamc*(exp(shadow_c2c))/(exp(shadow_c2mc)))^(c2rhoc/(1+c2rhoc)); 
 
// final consumption 
(exp(shadow_c2c)) = ((c2omegac)^(c2rhoc/(1+c2rhoc))*(exp(shadow_c2cd))^(1/(1+c2rhoc))+(c2omegamc)^(c2rhoc/(1+c2rhoc))*((exp(shadow_c2mc)))^(1/(1+c2rhoc)))^(1+c2rhoc); 
 
// definition of pstar 
(exp(shadow_c2pstar))^(1+(1+c2nup)/(c2nup)*c2chi) = (exp(shadow_c2hp))/(exp(shadow_c2gp)); 
 
// definition of hp 
(exp(shadow_c2hp)) = (1+(c2nup))/(c2nup) 
*c2chi0*(exp(shadow_c2y)/exp(shadow_c2z))^c2chi/((exp(shadow_c2c))^(-c2sigma)/exp(shadow_c2rpcpd))*exp(shadow_c2y) 
+ c2xip*c2beta*(((exp(shadow_c2c(+1)))^(-c2sigma)/exp(shadow_c2rpcpd(+1))))/(((exp(shadow_c2c))^(-c2sigma)/exp(shadow_c2rpcpd)))*((c2pistar)/(shadow_c2pid(+1)))^(-(1 
+(c2nup))/(c2nup)*(1+c2chi))*(exp(shadow_c2hp(+1))); 
 
// definition of gp 
(exp(shadow_c2gp)) = (1+c2taup*exp(shadow_c2taupvar))/(c2nup)*(exp(shadow_c2y))+c2xip*c2beta*(((exp(shadow_c2c(+1)))^(-c2sigma)/exp(shadow_c2rpcpd(+1))))/(((exp(shadow_c2c))^(-c2sigma)/exp(shadow_c2rpcpd)))*((c2pistar)/(shadow_c2pid(+1)))^(1 
-(1+(c2nup))/(c2nup))*(exp(shadow_c2gp(+1))); 
 
// price evolution 
(1-c2xip)*((exp(shadow_c2pstar)))^(-1/(c2nup))+c2xip*((c2pistar)/(shadow_c2pid))^(-1/(c2nup)) = 1; 
 
// evolution of price dispersion 
(exp(shadow_c2deltad)) = (1-c2xip)*((exp(shadow_c2pstar)))^(-(1+(c2nup))/(c2nup)*(1+c2chi)) 
+c2xip*((c2pistar)/(shadow_c2pid))^(-(1+(c2nup))/(c2nup)*(1+c2chi))*(exp(shadow_c2deltadlag)); 
 
// resource constraint goods 
(exp(shadow_c2y)) = (exp(shadow_c2cd))+(exp(shadow_c2g))+(c1relc2*(exp(shadow_c1mc))); 
 
// government spending 
(exp(shadow_c2g)) = c2sharegy*(exp(shadow_c2y))*(exp(shadow_c2shockgy)); 
 
// core inflation 
shadow_c2dcore = exp(shadow_c2rpcpd)/exp(shadow_c2rpcpdlag)*shadow_c2pid; 
 
//////////////////////// 
// international links 
//////////////////////// 
 
// risk sharing  
c2lambdaqss/((exp(shadow_c2c))^(-c2sigma))*c2rpcpdss = c1rerss/(exp(shadow_c1rer))*c1lambdaqss/((exp(shadow_c1c))^(-c1sigma))*c1rpcpdss; 
 
//////////////////////// 
// Preferences 
//////////////////////// 
 
// Utility, country 1 
shadow_Util1 = (exp(shadow_c1c))^(1-c1sigma)/(1-c1sigma)-c1chi0*(exp(shadow_c1z))^(-c1chi)*(exp(shadow_c1y))^(1+c1chi)/(1+c1chi)*exp(shadow_c1deltad); 
 
// Utility, country 2 
shadow_Util2 = (exp(shadow_c2c))^(1-c2sigma)/(1-c2sigma)-c2chi0*(exp(shadow_c2z))^(-c2chi)*(exp(shadow_c2y))^(1+c2chi)/(1+c2chi)*exp(shadow_c2deltad); 
 
 
///////////////////////// 
// exogenous variables 
///////////////////////// 
 
shadow_c1shockgy = c1rhogy*shadow_c1shockgy(-1) + c1sigmagy*c1shockgyerr; 
 
shadow_c1z = c1rhoz*shadow_c1z(-1) + c1sigmaz*c1zerr; 
 
shadow_c1taupvar = c1rhotaupvar*shadow_c1taupvar(-1)+c1sigmataupvarerr*c1taupvarerr; 
 
shadow_c2shockgy = c2rhogy*shadow_c2shockgy(-1) + c2sigmagy*c2shockgyerr; 
 
shadow_c2z = c2rhoz*shadow_c2z(-1) + c2sigmaz*c2zerr; 
 
shadow_c2taupvar = c2rhotaupvar*shadow_c2taupvar(-1)+c2sigmataupvarerr*c2taupvarerr; 
 
 
// REGULAR BLOCK 
 
// Policymaker's First-Order Conditions 
lmult19*exp(c1c) - lmult21*((c1chi0*c1sigma*exp(c1c)*exp(c1rpcpd)*exp(c1y)*exp(c1c)^(c1sigma - 1)*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1beta*c1sigma*c1xip*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1hp(+1))*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1))/(exp(c1c(+1))^c1sigma*(c1pistar/c1pid(+1))^(((c1chi + 1)*(c1nup + 1))/c1nup))) - (lmult15*exp(c1c))/exp(c1c)^c1sigma - (lmult41*exp(c1c))/exp(c1c)^c1sigma - (c1omegamc*c1rhoc*lmult18*exp(-c1mc)*exp(c1c)*(c1omegamc*exp(-c1mc)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - c1lambdaqss*c1rerss*c1rpcpdss*c1sigma*lmult40*exp(-c1rer)*exp(c1c)*exp(c1c)^(c1sigma - 1) + (c1omegac*c1rhoc*lmult17*exp(-c1cd)*exp(c1c)*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - (c1beta*c1sigma*lmult16*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1))/(c1pid(+1)*exp(c1c(+1))^c1sigma) + (c1beta*c1sigma*lmult16(-1)*exp(-c1rpcpd)*exp(c1c)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid*nbeta*exp(c1c)^(c1sigma + 1)) - (c1beta*c1sigma*c1xip*lmult22*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1gp(+1))*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1)*(c1pistar/c1pid(+1))^(1 - (c1nup + 1)/c1nup))/exp(c1c(+1))^c1sigma + (c1beta*c1sigma*c1xip*lmult22(-1)*exp(-c1rpcpd)*exp(c1c)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^(c1sigma + 1)) + (c1beta*c1sigma*c1xip*lmult21(-1)*exp(-c1rpcpd)*exp(c1c)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^(c1sigma + 1)*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)); 
- lmult25*exp(c1cd) - c1omegac^(c1rhoc/(c1rhoc + 1))*lmult19*exp(c1cd)*exp(c1cd)^(1/(c1rhoc + 1) - 1)*(c1omegac^(c1rhoc/(c1rhoc + 1))*exp(c1cd)^(1/(c1rhoc + 1)) + c1omegamc^(c1rhoc/(c1rhoc + 1))*exp(c1mc)^(1/(c1rhoc + 1)))^c1rhoc - (c1omegac*c1rhoc*lmult17*exp(-c1cd)*exp(c1c)*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1); 
lmult27; 
lmult24*exp(c1deltad) - lmult3(+1)*nbeta + (c1chi0*lmult41*exp(c1deltad)*exp(c1y)^(c1chi + 1))/(exp(c1z)^c1chi*(c1chi + 1)); 
lmult3 - lmult4(+1)*nbeta - (c1xip*lmult24*exp(c1deltadlag))/(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup); 
lmult4; 
lmult26*exp(c1g) - lmult25*exp(c1g); 
lmult22*exp(c1gp) + lmult20*exp(-c1gp)*exp(c1hp) - (c1beta*c1xip*lmult22(-1)*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^c1sigma); 
lmult21*exp(c1hp) - lmult20*exp(-c1gp)*exp(c1hp) - (c1beta*c1xip*lmult21(-1)*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)); 
(c1omegamc*c1rhoc*lmult18*exp(-c1mc)*exp(c1c)*(c1omegamc*exp(-c1mc)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - c1omegamc^(c1rhoc/(c1rhoc + 1))*lmult19*exp(c1mc)*exp(c1mc)^(1/(c1rhoc + 1) - 1)*(c1omegac^(c1rhoc/(c1rhoc + 1))*exp(c1cd)^(1/(c1rhoc + 1)) + c1omegamc^(c1rhoc/(c1rhoc + 1))*exp(c1mc)^(1/(c1rhoc + 1)))^c1rhoc - c1relc2*lmult37*exp(c1mc); 
(c1pistar*c1xip*lmult23)/(c1nup*c1pid^2*(c1pistar/c1pid)^(1/c1nup + 1)) - lmult27*exp(-c1rpcpdlag)*exp(c1rpcpd) - lmult1 + (c1beta*lmult16(-1)*exp(-c1rpcpd)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid^2*nbeta*exp(c1c)^c1sigma) - (c1pistar*c1xip*lmult24*exp(c1deltadlag)*(c1chi + 1)*(c1nup + 1))/(c1nup*c1pid^2*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)) - (c1beta*c1pistar*c1xip*lmult22(-1)*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*((c1nup + 1)/c1nup - 1))/(c1pid^2*nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^((c1nup + 1)/c1nup)) - (c1beta*c1pistar*c1xip*lmult21(-1)*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1chi + 1)*(c1nup + 1))/(c1nup*c1pid^2*nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)); 
lmult20*exp(c1pstar)*exp(c1pstar)^((c1chi*(c1nup + 1))/c1nup)*((c1chi*(c1nup + 1))/c1nup + 1) + (lmult23*exp(c1pstar)*(c1xip - 1))/(c1nup*exp(c1pstar)^(1/c1nup + 1)) - (lmult24*exp(c1pstar)*(c1chi + 1)*(c1nup + 1)*(c1xip - 1))/(c1nup*exp(c1pstar)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)); 
lmult18*exp(-c2rpcpd)*exp(c1rer) - lmult30*exp(-c1rer)*exp(-c1rpcpd) + c1lambdaqss*c1rerss*c1rpcpdss*lmult40*exp(-c1rer)*exp(c1c)^c1sigma; 
- lmult5(+1)*nbeta - lmult16/(c1rn + 1)^2; 
lmult5 - lmult6(+1)*nbeta; 
lmult6; 
lmult17*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1)) - lmult21*((c1chi0*exp(c1rpcpd)*exp(c1y)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1beta*c1xip*exp(-c1rpcpd(+1))*exp(c1hp(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma)/(exp(c1c(+1))^c1sigma*(c1pistar/c1pid(+1))^(((c1chi + 1)*(c1nup + 1))/c1nup))) - lmult30*exp(-c1rer)*exp(-c1rpcpd) - lmult7(+1)*nbeta - c1pid*lmult27*exp(-c1rpcpdlag)*exp(c1rpcpd) - (c1beta*lmult16*exp(-c1rpcpd(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma)/(c1pid(+1)*exp(c1c(+1))^c1sigma) + (c1beta*lmult16(-1)*exp(-c1rpcpd)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid*nbeta*exp(c1c)^c1sigma) - (c1beta*c1xip*lmult22*exp(-c1rpcpd(+1))*exp(c1gp(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma*(c1pistar/c1pid(+1))^(1 - (c1nup + 1)/c1nup))/exp(c1c(+1))^c1sigma + (c1beta*c1xip*lmult21(-1)*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)) + (c1beta*c1xip*lmult22(-1)*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^c1sigma); 
lmult7 - lmult8(+1)*nbeta + c1pid*lmult27*exp(-c1rpcpdlag)*exp(c1rpcpd); 
lmult8; 
lmult25*exp(c1y) - lmult21*((c1chi0*exp(c1rpcpd)*exp(c1y)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1chi*c1chi0*exp(2*c1y)*exp(-c1z)*exp(c1rpcpd)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^(c1chi - 1)*(c1nup + 1))/c1nup) - (lmult22*exp(c1y)*(c1taup*exp(c1taupvar) + 1))/c1nup - c1sharegy*lmult26*exp(c1shockgy)*exp(c1y) + (c1chi0*lmult41*exp(c1deltad)*exp(c1y)*exp(c1y)^c1chi)/exp(c1z)^c1chi; 
lmult31*exp(c2c) - lmult33*((c2chi0*c2sigma*exp(c2c)*exp(c2rpcpd)*exp(c2y)*exp(c2c)^(c2sigma - 1)*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2beta*c2sigma*c2xip*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2hp(+1))*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1))/(exp(c2c(+1))^c2sigma*(c2pistar/c2pid(+1))^(((c2chi + 1)*(c2nup + 1))/c2nup))) - (lmult42*exp(c2c))/exp(c2c)^c2sigma + c2lambdaqss*c2rpcpdss*c2sigma*lmult40*exp(c2c)*exp(c2c)^(c2sigma - 1) - (c2omegamc*c2rhoc*lmult30*exp(-c2mc)*exp(c2c)*(c2omegamc*exp(-c2mc)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) + (c2omegac*c2rhoc*lmult29*exp(-c2cd)*exp(c2c)*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) - (c2beta*c2sigma*lmult28*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1))/(c2pid(+1)*exp(c2c(+1))^c2sigma) + (c2beta*c2sigma*lmult28(-1)*exp(-c2rpcpd)*exp(c2c)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid*nbeta*exp(c2c)^(c2sigma + 1)) - (c2beta*c2sigma*c2xip*lmult34*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2gp(+1))*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1)*(c2pistar/c2pid(+1))^(1 - (c2nup + 1)/c2nup))/exp(c2c(+1))^c2sigma + (c2beta*c2sigma*c2xip*lmult34(-1)*exp(-c2rpcpd)*exp(c2c)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^(c2sigma + 1)) + (c2beta*c2sigma*c2xip*lmult33(-1)*exp(-c2rpcpd)*exp(c2c)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^(c2sigma + 1)*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)); 
- lmult37*exp(c2cd) - c2omegac^(c2rhoc/(c2rhoc + 1))*lmult31*exp(c2cd)*exp(c2cd)^(1/(c2rhoc + 1) - 1)*(c2omegac^(c2rhoc/(c2rhoc + 1))*exp(c2cd)^(1/(c2rhoc + 1)) + c2omegamc^(c2rhoc/(c2rhoc + 1))*exp(c2mc)^(1/(c2rhoc + 1)))^c2rhoc - (c2omegac*c2rhoc*lmult29*exp(-c2cd)*exp(c2c)*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1); 
lmult39; 
lmult36*exp(c2deltad) - lmult9(+1)*nbeta + (c2chi0*lmult42*exp(c2deltad)*exp(c2y)^(c2chi + 1))/(exp(c2z)^c2chi*(c2chi + 1)); 
lmult9 - lmult10(+1)*nbeta - (c2xip*lmult36*exp(c2deltadlag))/(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup); 
lmult10; 
lmult38*exp(c2g) - lmult37*exp(c2g); 
lmult34*exp(c2gp) + lmult32*exp(-c2gp)*exp(c2hp) - (c2beta*c2xip*lmult34(-1)*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^c2sigma); 
lmult33*exp(c2hp) - lmult32*exp(-c2gp)*exp(c2hp) - (c2beta*c2xip*lmult33(-1)*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)); 
(c2omegamc*c2rhoc*lmult30*exp(-c2mc)*exp(c2c)*(c2omegamc*exp(-c2mc)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) - c2omegamc^(c2rhoc/(c2rhoc + 1))*lmult31*exp(c2mc)*exp(c2mc)^(1/(c2rhoc + 1) - 1)*(c2omegac^(c2rhoc/(c2rhoc + 1))*exp(c2cd)^(1/(c2rhoc + 1)) + c2omegamc^(c2rhoc/(c2rhoc + 1))*exp(c2mc)^(1/(c2rhoc + 1)))^c2rhoc - (lmult25*exp(c2mc))/c1relc2; 
(c2pistar*c2xip*lmult35)/(c2nup*c2pid^2*(c2pistar/c2pid)^(1/c2nup + 1)) - lmult39*exp(-c2rpcpdlag)*exp(c2rpcpd) - lmult2 + (c2beta*lmult28(-1)*exp(-c2rpcpd)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid^2*nbeta*exp(c2c)^c2sigma) - (c2pistar*c2xip*lmult36*exp(c2deltadlag)*(c2chi + 1)*(c2nup + 1))/(c2nup*c2pid^2*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)) - (c2beta*c2pistar*c2xip*lmult34(-1)*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*((c2nup + 1)/c2nup - 1))/(c2pid^2*nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^((c2nup + 1)/c2nup)) - (c2beta*c2pistar*c2xip*lmult33(-1)*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2chi + 1)*(c2nup + 1))/(c2nup*c2pid^2*nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)); 
lmult32*exp(c2pstar)*exp(c2pstar)^((c2chi*(c2nup + 1))/c2nup)*((c2chi*(c2nup + 1))/c2nup + 1) + (lmult35*exp(c2pstar)*(c2xip - 1))/(c2nup*exp(c2pstar)^(1/c2nup + 1)) - (lmult36*exp(c2pstar)*(c2chi + 1)*(c2nup + 1)*(c2xip - 1))/(c2nup*exp(c2pstar)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)); 
- lmult11(+1)*nbeta - lmult28/(c2rn + 1)^2; 
lmult11 - lmult12(+1)*nbeta; 
lmult12; 
lmult29*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1)) - lmult33*((c2chi0*exp(c2rpcpd)*exp(c2y)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2beta*c2xip*exp(-c2rpcpd(+1))*exp(c2hp(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma)/(exp(c2c(+1))^c2sigma*(c2pistar/c2pid(+1))^(((c2chi + 1)*(c2nup + 1))/c2nup))) - lmult13(+1)*nbeta - lmult18*exp(-c2rpcpd)*exp(c1rer) - c2pid*lmult39*exp(-c2rpcpdlag)*exp(c2rpcpd) - (c2beta*lmult28*exp(-c2rpcpd(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma)/(c2pid(+1)*exp(c2c(+1))^c2sigma) + (c2beta*lmult28(-1)*exp(-c2rpcpd)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid*nbeta*exp(c2c)^c2sigma) - (c2beta*c2xip*lmult34*exp(-c2rpcpd(+1))*exp(c2gp(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma*(c2pistar/c2pid(+1))^(1 - (c2nup + 1)/c2nup))/exp(c2c(+1))^c2sigma + (c2beta*c2xip*lmult33(-1)*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)) + (c2beta*c2xip*lmult34(-1)*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^c2sigma); 
lmult13 - lmult14(+1)*nbeta + c2pid*lmult39*exp(-c2rpcpdlag)*exp(c2rpcpd); 
lmult14; 
lmult37*exp(c2y) - lmult33*((c2chi0*exp(c2rpcpd)*exp(c2y)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2chi*c2chi0*exp(2*c2y)*exp(-c2z)*exp(c2rpcpd)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^(c2chi - 1)*(c2nup + 1))/c2nup) - (lmult34*exp(c2y)*(c2taup*exp(c2taupvar) + 1))/c2nup - c2sharegy*lmult38*exp(c2shockgy)*exp(c2y) + (c2chi0*lmult42*exp(c2deltad)*exp(c2y)*exp(c2y)^c2chi)/exp(c2z)^c2chi; 
lmult1; 
lmult2; 
lmult41 + omega_welf1; 
lmult42 + omega_welf2; 
lmult15 - (c1beta*lmult15(-1))/nbeta; 
// Welfare Correction Term 
Welfcorrection =+lmult15(-1)*(Welfcon1(-1) - Welfcon1*c1beta + exp(c1c(-1))^(1 - c1sigma)/(c1sigma - 1))+lmult16(-1)*(1/(c1rn(-1) + 1) - (c1beta*exp(-c1rpcpd)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid*exp(c1c)^c1sigma))+lmult21(-1)*(exp(c1hp(-1)) - (c1chi0*exp(c1rpcpd(-1))*exp(c1y(-1))*exp(c1c(-1))^c1sigma*(exp(-c1z(-1))*exp(c1y(-1)))^c1chi*(c1nup + 1))/c1nup - (c1beta*c1xip*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)))+lmult22(-1)*(exp(c1gp(-1)) - (exp(c1y(-1))*(c1taup*exp(c1taupvar(-1)) + 1))/c1nup - (c1beta*c1xip*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/exp(c1c)^c1sigma)+lmult28(-1)*(1/(c2rn(-1) + 1) - (c2beta*exp(-c2rpcpd)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid*exp(c2c)^c2sigma))+lmult33(-1)*(exp(c2hp(-1)) - (c2chi0*exp(c2rpcpd(-1))*exp(c2y(-1))*exp(c2c(-1))^c2sigma*(exp(-c2z(-1))*exp(c2y(-1)))^c2chi*(c2nup + 1))/c2nup - (c2beta*c2xip*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)))+lmult34(-1)*(exp(c2gp(-1)) - (exp(c2y(-1))*(c2taup*exp(c2taupvar(-1)) + 1))/c2nup - (c2beta*c2xip*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/exp(c2c)^c2sigma); 
// Welfare Correction Term for the shadow file -- swap out after shadow file is created 
shadow_Welfcorrection =+lmult15(-1)*(Welfcon1(-1) - shadow_Welfcon1*c1beta + exp(c1c(-1))^(1 - c1sigma)/(c1sigma - 1))+lmult16(-1)*(1/(c1rn(-1) + 1) - (c1beta*exp(-shadow_c1rpcpd)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(shadow_c1pid*exp(shadow_c1c)^c1sigma))+lmult21(-1)*(exp(c1hp(-1)) - (c1chi0*exp(c1rpcpd(-1))*exp(c1y(-1))*exp(c1c(-1))^c1sigma*(exp(-c1z(-1))*exp(c1y(-1)))^c1chi*(c1nup + 1))/c1nup - (c1beta*c1xip*exp(-shadow_c1rpcpd)*exp(shadow_c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(exp(shadow_c1c)^c1sigma*(c1pistar/shadow_c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)))+lmult22(-1)*(exp(c1gp(-1)) - (exp(c1y(-1))*(c1taup*exp(c1taupvar(-1)) + 1))/c1nup - (c1beta*c1xip*exp(-shadow_c1rpcpd)*exp(shadow_c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/shadow_c1pid)^(1 - (c1nup + 1)/c1nup))/exp(shadow_c1c)^c1sigma)+lmult28(-1)*(1/(c2rn(-1) + 1) - (c2beta*exp(-shadow_c2rpcpd)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(shadow_c2pid*exp(shadow_c2c)^c2sigma))+lmult33(-1)*(exp(c2hp(-1)) - (c2chi0*exp(c2rpcpd(-1))*exp(c2y(-1))*exp(c2c(-1))^c2sigma*(exp(-c2z(-1))*exp(c2y(-1)))^c2chi*(c2nup + 1))/c2nup - (c2beta*c2xip*exp(-shadow_c2rpcpd)*exp(shadow_c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(exp(shadow_c2c)^c2sigma*(c2pistar/shadow_c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)))+lmult34(-1)*(exp(c2gp(-1)) - (exp(c2y(-1))*(c2taup*exp(c2taupvar(-1)) + 1))/c2nup - (c2beta*c2xip*exp(-shadow_c2rpcpd)*exp(shadow_c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/shadow_c2pid)^(1 - (c2nup + 1)/c2nup))/exp(shadow_c2c)^c2sigma); 
 
////////////////////////////////// 
// Utility and Welfare bloc 
////////////////////////////////// 
 
// Utility, aggregate  
Util = omega_welf1*Util1+omega_welf2*Util2; 
 
// Welfare, aggregate  
Welf = Util + nbeta*Welf(1); 
 
//// Welfare, agent 1 
Welf1 = Util1 + nbeta*Welf1(1); 
 
//// Welfare, agent 2 
Welf2 = Util2+ nbeta*Welf2(1); 
 
// Policy instrument, agent 1 
instr1 = c1pid; 
 
// Policy instrument, agent 2 
instr2 = c2pid; 
 
 c1deltadlag =c1deltad(-1);  
c1deltadlag2 =c1deltadlag(-1);  
c1rnlag =c1rn(-1);  
c1rnlag2 =c1rnlag(-1);  
c1rpcpdlag =c1rpcpd(-1);  
c1rpcpdlag2 =c1rpcpdlag(-1);  
c2deltadlag =c2deltad(-1);  
c2deltadlag2 =c2deltadlag(-1);  
c2rnlag =c2rn(-1);  
c2rnlag2 =c2rnlag(-1);  
c2rpcpdlag =c2rpcpd(-1);  
c2rpcpdlag2 =c2rpcpdlag(-1);  
  
////////////////////////////////// 
// Monetary policy bloc 
////////////////////////////////// 
 
 
 
//shadow_c1pid = shadow_c1rn_weight*(((shadow_c1rn+1)/(1+c1rnss)/((1+shadow_c1rnlag)/(1+c1rnss))^c1gamrn)^(1/(1-c1gamrn)/(1-c1gamdpc))) + (1-shadow_c1rn_weight)*c1pid; 
 
 
 
// Welfcon1 
Welfcon1 = (exp(c1c))^(1-c1sigma)/(1-c1sigma) + c1beta*Welfcon1(+1); 
 
 
////////////////////////////////// 
// Home country bloc  
////////////////////////////////// 
 
// definition of nominal interest rate  
1/(1+(c1rn)) = c1beta*(((exp(c1c(+1)))^(-c1sigma)/exp(c1rpcpd(+1))))/(((exp(c1c))^(-c1sigma)/exp(c1rpcpd)))/c1pid(+1); 
 
// fonc domestic consumption good 
exp(c1rpcpd)*(c1omegac*exp(c1c)/exp(c1cd))^(c1rhoc/(1+c1rhoc)) = 1; 
 
// fonc imported good 
(exp(c1rer))/(exp(c2rpcpd))= (c1omegamc*exp(c1c)/exp(c1mc))^(c1rhoc/(1+c1rhoc)); 
 
// final consumption  
exp(c1c) = ((c1omegac)^(c1rhoc/(1+c1rhoc))*exp(c1cd)^(1/(1+c1rhoc))+(c1omegamc)^(c1rhoc/(1+c1rhoc))*(exp(c1mc))^(1/(1+c1rhoc)))^(1+c1rhoc); 
 
// definition of pstar 
(exp(c1pstar))^(1+(1+c1nup)/(c1nup)*c1chi) = (exp(c1hp))/(exp(c1gp)); 
 
// definition of hp 
(exp(c1hp)) = (1+(c1nup))/(c1nup) 
*c1chi0*(exp(c1y)/exp(c1z))^(c1chi)/((exp(c1c))^(-c1sigma)/exp(c1rpcpd))*exp(c1y) 
+ c1xip*c1beta*(((exp(c1c(+1)))^(-c1sigma)/exp(c1rpcpd(+1))))/(((exp(c1c))^(-c1sigma)/exp(c1rpcpd)))*((c1pistar)/(c1pid(+1)))^(-(1 
+(c1nup))/(c1nup)*(1+c1chi))*(exp(c1hp(+1))); 
 
// definition of gp 
(exp(c1gp)) = (1+c1taup*exp(c1taupvar))/(c1nup)*(exp(c1y))+c1xip*c1beta*(((exp(c1c(+1)))^(-c1sigma)/exp(c1rpcpd(+1))))/(((exp(c1c))^(-c1sigma)/exp(c1rpcpd)))*((c1pistar)/(c1pid(+1)))^(1 
-(1+(c1nup))/(c1nup))*(exp(c1gp(+1))); 
 
// price evolution 
(1-c1xip)*((exp(c1pstar)))^(-1/(c1nup))+c1xip*((c1pistar)/(c1pid))^(-1/(c1nup)) = 1; 
 
// evolution of price dispersion 
(exp(c1deltad)) = (1-c1xip)*((exp(c1pstar)))^(-(1+(c1nup))/(c1nup)*(1+c1chi)) 
+c1xip*((c1pistar)/(c1pid))^(-(1+(c1nup))/(c1nup)*(1+c1chi))*(exp(c1deltadlag)); 
 
// resource constraint goods 
exp(c1y) = exp(c1cd)+exp(c1g)+1/c1relc2*(exp(c2mc)); 
 
// government spending 
exp(c1g) = c1sharegy*exp(c1y)*exp(c1shockgy); 
 
// core inflation 
c1dcore = exp(c1rpcpd)/exp(c1rpcpdlag)*c1pid; 
 
////////////////////////////////// 
// Foreign country bloc  
////////////////////////////////// 
 
// definition of nominal interest rate 
1/(1+(c2rn)) = c2beta*(((exp(c2c(+1)))^(-c2sigma)/exp(c2rpcpd(+1))))/(((exp(c2c))^(-c2sigma)/exp(c2rpcpd)))/c2pid(+1); 
 
// fonc domestic consumption good 
(exp(c2rpcpd))*(c2omegac*(exp(c2c))/(exp(c2cd)))^(c2rhoc/(1+c2rhoc)) = 1; 
 
// fonc imported good 
1/(exp(c1rer))/(exp(c1rpcpd)) = (c2omegamc*(exp(c2c))/(exp(c2mc)))^(c2rhoc/(1+c2rhoc)); 
 
// final consumption 
(exp(c2c)) = ((c2omegac)^(c2rhoc/(1+c2rhoc))*(exp(c2cd))^(1/(1+c2rhoc))+(c2omegamc)^(c2rhoc/(1+c2rhoc))*((exp(c2mc)))^(1/(1+c2rhoc)))^(1+c2rhoc); 
 
// definition of pstar 
(exp(c2pstar))^(1+(1+c2nup)/(c2nup)*c2chi) = (exp(c2hp))/(exp(c2gp)); 
 
// definition of hp 
(exp(c2hp)) = (1+(c2nup))/(c2nup) 
*c2chi0*(exp(c2y)/exp(c2z))^c2chi/((exp(c2c))^(-c2sigma)/exp(c2rpcpd))*exp(c2y) 
+ c2xip*c2beta*(((exp(c2c(+1)))^(-c2sigma)/exp(c2rpcpd(+1))))/(((exp(c2c))^(-c2sigma)/exp(c2rpcpd)))*((c2pistar)/(c2pid(+1)))^(-(1 
+(c2nup))/(c2nup)*(1+c2chi))*(exp(c2hp(+1))); 
 
// definition of gp 
(exp(c2gp)) = (1+c2taup*exp(c2taupvar))/(c2nup)*(exp(c2y))+c2xip*c2beta*(((exp(c2c(+1)))^(-c2sigma)/exp(c2rpcpd(+1))))/(((exp(c2c))^(-c2sigma)/exp(c2rpcpd)))*((c2pistar)/(c2pid(+1)))^(1 
-(1+(c2nup))/(c2nup))*(exp(c2gp(+1))); 
 
// price evolution 
(1-c2xip)*((exp(c2pstar)))^(-1/(c2nup))+c2xip*((c2pistar)/(c2pid))^(-1/(c2nup)) = 1; 
 
// evolution of price dispersion 
(exp(c2deltad)) = (1-c2xip)*((exp(c2pstar)))^(-(1+(c2nup))/(c2nup)*(1+c2chi)) 
+c2xip*((c2pistar)/(c2pid))^(-(1+(c2nup))/(c2nup)*(1+c2chi))*(exp(c2deltadlag)); 
 
// resource constraint goods 
(exp(c2y)) = (exp(c2cd))+(exp(c2g))+(c1relc2*(exp(c1mc))); 
 
// government spending 
(exp(c2g)) = c2sharegy*(exp(c2y))*(exp(c2shockgy)); 
 
// core inflation 
c2dcore = exp(c2rpcpd)/exp(c2rpcpdlag)*c2pid; 
 
//////////////////////// 
// international links 
//////////////////////// 
 
// risk sharing  
c2lambdaqss/((exp(c2c))^(-c2sigma))*c2rpcpdss = c1rerss/(exp(c1rer))*c1lambdaqss/((exp(c1c))^(-c1sigma))*c1rpcpdss; 
 
//////////////////////// 
// Preferences 
//////////////////////// 
 
// Utility, country 1 
Util1 = (exp(c1c))^(1-c1sigma)/(1-c1sigma)-c1chi0*(exp(c1z))^(-c1chi)*(exp(c1y))^(1+c1chi)/(1+c1chi)*exp(c1deltad); 
 
// Utility, country 2 
Util2 = (exp(c2c))^(1-c2sigma)/(1-c2sigma)-c2chi0*(exp(c2z))^(-c2chi)*(exp(c2y))^(1+c2chi)/(1+c2chi)*exp(c2deltad); 
 
 
///////////////////////// 
// exogenous variables 
///////////////////////// 
 
c1shockgy = c1rhogy*c1shockgy(-1) + c1sigmagy*c1shockgyerr; 
 
c1z = c1rhoz*c1z(-1) + c1sigmaz*c1zerr; 
 
c1taupvar = c1rhotaupvar*c1taupvar(-1)+c1sigmataupvarerr*c1taupvarerr; 
 
c2shockgy = c2rhogy*c2shockgy(-1) + c2sigmagy*c2shockgyerr; 
 
c2z = c2rhoz*c2z(-1) + c2sigmaz*c2zerr; 
 
c2taupvar = c2rhotaupvar*c2taupvar(-1)+c2sigmataupvarerr*c2taupvarerr; 
 
end; 
 
 
shocks; 
var c1zerr = 1;  
var c2zerr = 1; 
var c2taupvarerr = 1; 
var c1taupvarerr = 1; 
end; 
 
 
stoch_simul(order=2,nocorr,nomoments,irf=0); 
